-- Font.e
-- Created by No Solution.

--------------------------------- TIP ----------------------------------------
--How to load and use multiple fonts:
--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
--Declare a sequence with whatever name you wish. See the code below.

--  sequence MyFont
--  MyFont = Font

--This copies the current font into the sequence you declared, in this case
--MyFont. Now, to use this font as the current font just assign the Font
--sequence(declared in font.e) to MyFont. See the code below.

--  Font = MyFont
------------------------------------------------------------------------------


include get.e
include image.e
include graphics.e

-- This is the loaded font.
global sequence Font

-- This changes a character's color.(not a global function)
function ChangeCharColor(atom color, sequence Char)
  sequence ret
  ret = Char
  for a = 1 to length(ret) do
    for b = 1 to length(ret[a]) do
      if ret[a][b] > 0 then
        ret[a][b] = color
      end if
    end for
  end for

  return ret
end function

-- Saves the current font to the specified file.
global procedure SaveFont(sequence fname)
  atom fn
  fn = open(fname,"w")
  print(fn,Font)
  close(fn)
end procedure

-- Loads the specified file into the current font.
global procedure LoadFont(sequence fname)
  atom fn
  sequence s
  fn = open(fname,"r")
  s = get(fn)
  Font = s[2]
end procedure

-- Constructs a basic font made from the default font that the BIOS uses.
-- I saved this to a file called bios.fnt
global procedure MakeFont()
  sequence char
  Font = {}

  for i = 0 to 255 do
    position(1,1)
    puts(1,i)
    char = save_image({0,0},{8,8})
    Font = append(Font,char)
  end for

end procedure

-- The main purpose of this font lib.
global procedure outtextxy(atom color,sequence pos, sequence string)
  sequence char

  if length(Font) = 256 then
    for i = 1 to length(string) do
      char = Font[string[i]+1]
      char = ChangeCharColor(color,char)
      display_image({pos[1]+((i-1)*8),pos[2]},char)
    end for
  end if

end procedure

global function intextxy(atom color, sequence pos)
  atom char,x,y
  sequence s,a
  
  char = -1
  x = pos[1]
  y = pos[2]
  s = ""
  a = " "

  while char != 13 do
    char = wait_key()
    if char != 8 and char != 13 then
      a[1] = char
      outtextxy(color,{x,y},a)
      s = s & char
      x = x + 8
    end if
    if char = 8 and x > pos[1] then
      x = x - 8
      outtextxy(color,{x,y}," ")
      s = s[1..length(s)-1]
    end if
  end while

  return s
end function




